-- AggroMonitor for RIFT by Vritra

local AM = {
	ALLY = nil,
	Agg = {{name,role},{name,role}},
	InCombat = false,
	Reverse = false,
	Count = 0,
}

local function GetDetail(unit, member)
	local d = Inspect.Unit.Detail(unit) or false
	if d then
		for k, v in pairs(d) do
			if k == member then
				return(v)
			end
		end
	end
end

local function GetEnable()
	local unitList = Inspect.Unit.List()
	local tank = false
	local ppl = 0
	if unitList then
		for k in pairs(unitList) do
			local role = GetDetail(k, "role")
			if role then
				ppl = ppl + 1
				if role == "tank" then
					tank = true
				end
			end
		end
	end
	if ppl > 1 and tank then
		return(false)
	else
		return(true)
	end
end

local function GetInCombat()
	local c = false
	local unitList = Inspect.Unit.List()
	if unitList then
		for k in pairs(unitList) do
			local com = GetDetail(k, "combat")
			local r = GetDetail(k, "role")
			if com and r then
				c = true
			end
		end
	end
	return(c)
end

local function AgglistReset()
	AM.Agg = {{name=nil,role=nil},{name=nil,role=nil}}
	AM.Reverse = false
	AM.Count = 0
end
table.insert(Event.System.Secure.Leave, {AgglistReset, "AggroMonitor", "SecureLeave"})

local function Capitalize(str)
	return(string.upper(string.sub(str, 1, 1))..string.lower(string.sub(str, 2)))
end

local function DetailCombat(val)	--UnitId=str, InCombat=bool
	if AM.ALLY == nil then
		AM.ALLY = GetDetail("player", "alliance")
	end

	if not GetInCombat() then
		AM.InCombat = false
		AgglistReset()
		return
	elseif not AM.InCombat then
		for k, v in pairs(val) do
			if v then
				local rel, ally, r, pc, n
				local d = Inspect.Unit.Detail(k) or false
				if d then
					for a, b in pairs(d) do
						if a == "relation" then
							rel = b
						elseif a == "alliance" then
							ally = b
						elseif a == "role" then
							r = b
						elseif a == "player" then
							pc = b
						elseif a == "name" then
							n = b
						end
					end
				end

				if rel then
				local mob = false
					if rel == "friendly" then
						if ally == AM.ALLY then
							if r == nil then
								if pc then
									r = Capitalize(ally)
								else
									r = "pet"
								end
							elseif r == "tank" then
								AM.InCombat = true
								break
							end
						else
							mob = true
						end
					end
					if mob == false then
						local agg = {name=n, role=r}
						if not AM.Agg[1].name then
							AM.Agg[1] = agg
						elseif type(AM.Agg[1].role) ~= type(r) then
							AM.Agg[2] = agg
							break
						end
					end
				end
			end
		end

		if AM.Agg[2].name then
			AM.InCombat = true
			if GetEnable() then return end
			if AM.Agg[2].role then
				if AM.Reverse then
					print(AM.Agg[1].name.." aggro to "..AM.Agg[2].name.." ("..AM.Agg[2].role..").")
				else
					print(AM.Agg[2].name.." ("..AM.Agg[2].role..") engage to "..AM.Agg[1].name..".")
				end
			else
				if AM.Reverse then
					print(AM.Agg[2].name.." aggro to "..AM.Agg[1].name.." ("..AM.Agg[1].role..").")
				else
					print(AM.Agg[1].name.." ("..AM.Agg[1].role..") engage to "..AM.Agg[2].name..".")
				end
			end
			AgglistReset()
		end

		AM.Count = AM.Count + 1
		if AM.Count > 3 then
			if AM.InCombat == false then
				AM.InCombat = true
				if GetEnable() then return end
				if AM.Agg[1].name then
					local str = ""
					if AM.Agg[1].role then
						str = " ("..AM.Agg[1].role..")"
					end
					print(AM.Agg[1].name..str.." aggro.")
				end
				AgglistReset()
			end
		end
	end
end
table.insert(Event.Unit.Detail.Combat, {DetailCombat, "AggroMonitor", "DetailCombat"})

table.insert(Event.Unit.Detail.Aggro, {function(val)
	AM.Reverse = true
	DetailCombat(val)
end, "AggroMonitor", "DetailAggro"})
